<?php

namespace Drupal\media_delete_all\Controller;

use Drupal\media_delete_all\Controller\DeleteControllerBase;

/**
 * Returns responses for devel module routes.
 */
class MediaDeleteController extends DeleteControllerBase {
  /**
   * Get nids of the nodes to delete.
   *
   * @param array $roles
   *   Array of roles.
   *
   * @return array
   *   Array of nids of nodes to delete.
   */
  public function getMediaToDelete($media_types = FALSE) {
    $medias_to_delete = [];

    // Delete media  by media type.
    if ($media_types !== FALSE) {
      $media_to_delete = [];
      foreach ($media_types as $media_type) {
        if ($media_type) {
          $mids = $this->connection->select('media', 'm')
                    ->fields('m', ['mid'])
                    ->condition('bundle', $media_type)
                    ->execute()
                    ->fetchCol('mid');

          $medias_to_delete = array_merge($medias_to_delete, $mids);
        }
      }
    }
    // Delete all content.
    else {
      $medias_to_delete = FALSE;
    }

    return $medias_to_delete;
  }

  /**
   *
   */
  public function getMediatDeleteBatch($medias_to_delete = FALSE) {
    module_load_include('inc', 'media_delete_all', 'includes/delete_all_media_batch_delete');
   // var_dump($medias_to_delete);die();
    // Define batch.
    $batch = [
      'operations' => array(
        array(
          '\Drupal\media_delete_all\DeleteMediaBatchController::delete_all_media_batch_delete',
          array($medias_to_delete)
        ),
      ),
      'finished' => '\Drupal\media_delete_all\DeleteMediaBatchController::delete_all_media_batch_delete_finished',
      'title' => $this->t('Deleting Media'),
      'init_message' => $this->t('Media deletion is starting.'),
      'progress_message' => $this->t('Deleting Media...'),
      'error_message' => $this->t('Media deletion has encountered an error.'),
    ];

 
    return $batch;
  }
}
